////////////////////////////////////////////////////////////////////////////
//
// nrMaterial.cpp
//
// A class for materials.
//
// Nate Robins, January 2002.
//
////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////

#include "nrMaterialLibrary.h"

#include "nrLog.h"
#include "nrMaterial.h"


////////////////////////////////////////////////////////////////////////////
// Static
////////////////////////////////////////////////////////////////////////////

nrArray< nrMaterial* > nrMaterialLibrary::m_Materials;


////////////////////////////////////////////////////////////////////////////
// Public
////////////////////////////////////////////////////////////////////////////

nrMaterialLibrary::nrMaterialLibrary( void )
{
}

////////////////////////////////////////////////////////////////////////////

nrMaterialLibrary::~nrMaterialLibrary( void )
{
}

////////////////////////////////////////////////////////////////////////////

void nrMaterialLibrary::Add( nrMaterial* material )
{
    assert( material );

    if ( Find( material->m_Name ) == 0 )
    {
        m_Materials.Add( material );
    }
    else
    {
        g_Log.Write( "nrMaterialLibrary::Add(): Material \"%s\" already in library.\n", material->m_Name );
    }
}

////////////////////////////////////////////////////////////////////////////

nrMaterial* nrMaterialLibrary::Find( const char* name )
{
    if ( name )
    {
        for ( int i = 0; i < m_Materials.Length(); i++ )
        {
            if ( m_Materials[ i ]->GetName() )
            {
                if ( strcmp( m_Materials[ i ]->GetName(), name ) == 0 )
                {
                    return m_Materials[ i ];
                }
            }
        }
    }
    
    return 0;
}

////////////////////////////////////////////////////////////////////////////

void nrMaterialLibrary::Initialize( void )
{
    assert( m_Materials.Length() == 0 );
}

////////////////////////////////////////////////////////////////////////////

void nrMaterialLibrary::Terminate( void )
{
    for ( int i = 0; i < m_Materials.Length(); i++ )
    {
        delete m_Materials[ i ];
    }
}

////////////////////////////////////////////////////////////////////////////
