////////////////////////////////////////////////////////////////////////////
//
// nrModelMTL.h
//
// Nate Robins, January 2002.
//
// Wavefront material file format reader.
//
////////////////////////////////////////////////////////////////////////////

#ifndef NRMODELMTL_H
#define NRMODELMTL_H


////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////

#include <stdio.h>


////////////////////////////////////////////////////////////////////////////
// Classes
////////////////////////////////////////////////////////////////////////////

class nrModel;

////////////////////////////////////////////////////////////////////////////

class nrModelMTL
{
public:
    // Read a Wavefront MTL material file.
    static bool Read( const char* material_file, nrModel* model );
    
private:
    nrModelMTL();
    ~nrModelMTL();
    
private:
    // Parse the MTL file.
    void Parse( void );
    
private:
    // File reading utilities.
    bool NextLine( void );
    void Loading( void );
    
private:
    nrModel* m_Model;      // Model that we're populating.
    FILE* m_File;          // File from which materials are being read.
    
    char* m_Line;          // Current line in the file.
    int m_LineNum;         // Current line number in the file.
    
    int m_TotalBytes;      // Total number of bytes to be read.
    int m_NumBytes;        // Current number of bytes read.
};

////////////////////////////////////////////////////////////////////////////

#endif    // NRMODELMTL_H
