////////////////////////////////////////////////////////////////////////////
//
// nrPixel.h
//
// A class for pixels.
//
// Nate Robins, April 2001.
//
////////////////////////////////////////////////////////////////////////////

#ifndef NRPIXEL_H
#define NRPIXEL_H


////////////////////////////////////////////////////////////////////////////
// Classes
////////////////////////////////////////////////////////////////////////////

class nrPixel
{
public:
    
    nrPixel( void );
    nrPixel( unsigned char r, unsigned char g, unsigned char b, unsigned char a = 255 );
    
    // Return a pixel that is linearly interpolated between a and b by 
    // amount t.
    static nrPixel Lerp( const nrPixel& a, const nrPixel& b, float t );
    
public:
    
    unsigned char r;
    unsigned char g;
    unsigned char b;
    unsigned char a;
};

////////////////////////////////////////////////////////////////////////////

#endif  // NRPIXEL_H
